
Foreman - Bug #12603

Host edit slow to load with many network interfaces

11/25/2015 08:11 AM - Sergio Traldi

Status: New   

Priority: Normal   

Assignee:    

Category: Performance   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.7.5

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Hi,

we have foreman 1.7.5-1 and about 100 hosts magaged by foreman.

The Database is in a cluster percona of three hosts dedicated. We have some hosts managed by foreman which are compute nodes

of a openstack cloud.

Each host (compute node) has libvit (kvm) installed and has one or more bridges and openstack creates many vitual interfaces.

When I try to Edit one host in foreman gui, many time it takes about 5 minutes or more, and sometimes a javascrit stuck and firefox

ask me to continue or sto script.

In the porduction log I see a lot of:

....

Rendered nic/manageds/_managed.html.erb (8.9ms)

Rendered nic/_base_form.html.erb (6.7ms)

Rendered nic/_virtual_form.html.erb (0.9ms)

Rendered nic/manageds/_managed.html.erb (8.8ms)

Rendered nic/_base_form.html.erb (6.5ms)

Rendered nic/_virtual_form.html.erb (0.8ms)

Rendered nic/manageds/_managed.html.erb (8.7ms)

Rendered nic/_base_form.html.erb (6.4ms)

Rendered nic/_virtual_form.html.erb (0.8ms)

....

The best think shoud be if I can choose to wait a lot of time or setting some parameter o facter to disable the rendering of virtual nics.

(I don't need their)

Can someone help?

I have a look to bug or performance issue, and I found:

http://projects.theforeman.org/issues/7259

http://projects.theforeman.org/issues/3145

http://projects.theforeman.org/issues/11657

But one of the bug is for parameter issue, the other is for database caching, and the last is an aggregate of multiple performance

issues.

Cheers

Sergio

History

#1 - 12/11/2015 04:38 AM - Sergio Traldi

In addiction I have a look to this issue:

http://projects.theforeman.org/issues/9104

http://projects.theforeman.org/issues/3864

And I have the ignore_puppet_facts_for_provisioning set to true

The better things should be if that parameter works fine or if the parameters could be set for some specific host or in an hostgroup.
#2 - 03/20/2016 09:43 AM - Tomer Brisker

- Status changed from New to Need more information

Hello Sergio,

Thank you for your report!

Networking has undergone serious improvements in newer versions of Foreman, especially 1.8.

Please try upgrading to a newer version (1.10.2 is the latest stable version at the time of writing) and check if errors still occur.

If so, please include more details as to what errors exactly you are seeing as well as relevant portions from the production.log with the "debug" option

enabled.

If you need any assistance in performing the upgrades or enabling debug, you are welcome to join us on IRC at #theforeman on freenode or by mail

at foreman-users@googlegroups.com

#3 - 04/15/2016 05:50 AM - Sergio Traldi

Hi,

today I update the foreman to version 1.11.0

I have an host called cld-corso-11.pd.infn.it in a specific hostgroup. When I try to edit the host I have same beavihours. I have to wait about 5 minutes

and sometimes with firefox in a linux redhat host I obtain this error:

A script on this page may be busy, or it may have stopped responding. You can stop the script now, open the script in the debugger, or let the script

continue.

Script: https://cld-foreman.cloud.pd.i…3fa5d1038d3e10a03e4a4f8d728.js:25

the script start with:

/*!  * jQuery JavaScript Library v1.11.0  * http://jquery.com/  *  * Includes Sizzle.js  * http://sizzlejs.com/  *  * Copyright 2005, 2014 jQuery Foundation,

Inc. and other contributors  * Released under the MIT license  * http://jquery.org/license  *  * Date: 2014-01-23T21:02Z

*/

And at line 25 there is:

function(e){function t(e,t,a,o){var r,s,i,n,l,u,c,m,f,g;if((t?t.ownerDocument||t:H)!==L&&F(t),t=t||L,a=a||[],!e||"string"!=typeof e)return

a;if(1!==(n=t.nodeType)&&9!==n)return[];if(N&&!o){if(r=bt.exec(e))if(i=r

1

){if(9===n){if(s=t.getElementById(i),!s||!s.parentNode)return a;if(s.id===i)return

a.push(s),a}else if(t.ownerDocument&&(s=t.ownerDocument.getElementById(i))&&B(t,s)&&s.id===i)return a.push(s),a}else{if(r

2

)return

Z.apply(a,t.getElementsByTagName(e)),a;if((i=r

3

)&&C.getElementsByClassName&&t.getElementsByClassName)return

Z.apply(a,t.getElementsByClassName(i)),a}if(C.qsa&&(!M||!M.test(e))){if(m=c=z,f=t,g=9===n&&e,1===n&&"object"!==t.nodeName.toLowerCase()){for

(u=p(e),(c=t.getAttribute("id"))?m=c.replace(wt,"\\$&"):t.setAttribute("id",m),m="[id='"+m+"']

",l=u.length;l--;)u[l]=m+h(u[l]);f=yt.test(e)&&d(t.parentNode)||t,g=u.join(",")}if(g)try{return

Z.apply(a,f.querySelectorAll(g)),a}catch(v){}finally{c||t.removeAttribute("id")}}}return A(e.replace(lt,"$1"),t,a,o)}function a(){function e(a,o){return

t.push(a+" ")>P.cacheLength&&delete e[t.shift()],e[a+" "]=o}var t=[];return e}function o(e){return e[z]=!0,e}function r(e){var

t=L.createElement("div");try{return!!e(t)}catch(a){return!1}finally{t.parentNode&&t.parentNode.removeChild(t),t=null}}function s(e,t){for(var

a=e.split("|"),o=e.length;o--;)P.attrHandle[a[o]]=t}function i(e,t){var a=t&&e,o=a&&1===e.nodeType&&1===t.nodeType&&(

t.sourceIndex||W)-(~e.sourceIndex||W);if(o)return o;if(a)for(;a=a.nextSibling;)if(a===t)return-1;return e?1:-1}function n(e){return function(t){var a=t.nodeName.toLowerCase();return"input"===a&&t.type===e}}function l(e){return

function(t){var a=t.nodeName.toLowerCase();return("input"===a||"button"===a)&&t.type===e}}function u(e){return o(function(t){return t=+t,o(function(a,o){for(var

r,s=e([],a.length,t),i=s.length;i--;)a[r=s[i]]&&(a[r]=!(o[r]=a[r]))})})}function d(e){return e&&typeof e.getElementsByTagName!==K&&e}function c(){}function p(e,a){var o,r,s,i,n,l,u,d=q[e+" "];if(d)return

a?0:d.slice(0);for(n=e,l=[],u=P.preFilter;n;){(!o||(r=ut.exec(n)))&&(r&&(n=n.slice(r

0

.length)||n),l.push(s=[])),o=!1,(r=dt.exec(n))&&(o=r.shift(),s.push({value:o,type:r

0

.replace(lt," ")}),n=n.slice(o.length));for(i in

P.filter)!(r=mt[i].exec(n))||u[i]&&!(r=u[i](r))||(o=r.shift(),s.push({value:o,type:i,matches:r}),n=n.slice(o.length));if(!o)break}return a?n.length:n?t.error(e):q(e,l).slice(0)}function h(e){for(var
t=0,a=e.length,o="";a>t;t++)o+=e[t].value;return o}function m(e,t,a){var o=t.dir,r=a&&"parentNode"===o,s=$++;return t.first?function(t,a,s){for(;t=t[o];)if(1===t.nodeType||r)return e(t,a,s)}:function(t,a,i){var

n,l,u=[O,s];if(i){for(;t=t[o];)if((1===t.nodeType||r)&&e(t,a,i))return!0}else for(;t=t[o];)if(1===t.nodeType||r){if(l=t[z]||(t[z]={}),(n=l[o])&&n

0

===O&&n

1

===s)return u

2

=n

2

;if(l[o]=u,u

2

=e(t,a,i))return!0}}}function f(e){return

e.length>1?function(t,a,o){for(var r=e.length;r--;)if(!e[r](t,a,o))return!1;return!0}:e

0

}function g(e,t,a,o,r){for(var s,i=[],n=0,l=e.length,u=null!=t;l>n;n++)(s=e[n])&&(!a||a(s,o,r))&&(i.push(s),u&&t.push(n));return i}function

v(e,t,a,r,s,i){return r&&!r[z]&&(r=v(r)),s&&!s[z]&&(s=v(s,i)),o(function(o,i,n,l){var

u,d,c,p=[],h=[],m=i.length,f=o||w(t||"*",n.nodeType?[n]:n,[]),v=!e||!o&&t?f:g(f,p,e,n,l),b=a?s||(o?e:m||r)?[]:i:v;if(a&&a(v,b,n,l),r)for(u=g(b,h),r(u,[],n,l),d=u.length;d--;)(c=u[d])&&(b[h[d]]=!(v[h[d]]=c));if(o){if(s||e){if(s){for(u=[],d=b.lengt

h;d--;)(c=b[d])&&u.push(v[d]=c);s(null,b=[],u,l)}for(d=b.length;d--;)(c=b[d])&&(u=s?tt.call(o,c):p[d])>1&&(o[u]=!(i[u]=c))}}else b=g(b===i?b.splice(m,b.length):b),s?s(null,i,b,l):Z.apply(i,b)})}function b(e){for(var

t,a,o,r=e.length,s=P.relative[e

0

.type],i=s||P.relative[" "],n=s?1:0,l=m(function(e){return e===t},i,!0),u=m(function(e){return

tt.call(t,e)>-1},i,!0),d=[function(e,a,o){return!s&&(o||a!==k)||((t=a).nodeType?l(e,a,o):u(e,a,o))}];r>n;n++)if(a=P.relative[e[n].type])d=[m(f(d),a)];else{if(a=P.filter[e[n].type].apply(null,e[n].matches),a[z]){for(o=++n;r>o&&!P.relative[

e[o].type];o++);return v(n>1&&f(d),n>1&&h(e.slice(0,n-1).concat({value:" "===e[n-2].type?"*":""})).replace(lt,"$1"),a,o>n&&b(e.slice(n,o)),r>o&&b(e=e.slice(o)),r>o&&h(e))}d.push(a)}return f(d)}function y(e,a){var

r=a.length>0,s=e.length>0,i=function(o,i,n,l,u){var

d,c,p,h=0,m="0",f=o&&[],v=[],b=k,y=o||s&&P.find.TAG,w=O+=null==b?1:Math.random()||.1,A=y.length;for(u&&(k=i!==L&&i);m!==A&&null!=(d=y[m]);m++){if(s&&d){for(c=0;p=e[c++];)if(p(d,i,n)){l.push(d);break}u&&(O=w)}r&&((d

=!p&&d)&&h-,o&&f.push(d))}if(h+=m,r&&m!==h){for(c=0;p=a[c++];)p(f,v,i,n);if(o){if(h>0)for(;m--;)f[m]||v[m]||(v[m]=X.call(l));v=g(v)}Z.apply(l,v),u&&!o&&v.length>0&&h+a.length>1&&t.uniqueSort(l)}return u&&(O=w,k=b),f};return

r?o(i):i}function w(e,a,o){for(var r=0,s=a.length;s>r;r++)t(e,a[r],o);return o}function A(e,t,a,o){var r,s,i,n,l,u=p(e);if(!o&&1===u.length){if(s=u

0

=u

0

.slice(0),s.length>2&&"ID"===(i=s

0

).type&&C.getById&&9===t.nodeType&&N&&P.relative[s

1

.type]){if(t=(P.find.0.replace(At,St">ID,t)||[])[0],!t)return

a;e=e.slice(s.shift().value.length)}for(r=mt.needsContext.test(e)?0:s.length;r--&&(i=s[r],!P.relative[n=i.type]);)if((l=P.find[n])&&(o=l(i.matches

0

.replace(At,St),yt.test(s

0

.type)&&d(t.parentNode)||t))){if(s.splice(r,1),e=o.length&&h(s),!e)return Z.apply(a,o),a;break}}return x(e,u)(o,t,!N,a,yt.test(e)&&d(t.parentNode)||t),a}var S,C,P,_,D,x,k,E,I,F,L,T,N,M,R,U,B,z="sizzle"+-new

Date,H=e.document,O=0,$=0,V=a(),q=a(),G=a(),j=function(e,t){return e===t&&(I=!0),0},K="undefined",W=1<<31,Y={}.hasOwnProperty,Q=[],X=Q.pop,J=Q.push,Z=Q.push,et=Q.slice,tt=Q.indexOf||function(e){for(var

t=0,a=this.length;a>t;t++)if(this[t]===e)return

t;return-1},at="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",ot="[\\x20\\t\\r\\n\\f]",rt="(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",st=rt.replace("w","w#"),it="\\["+o
t+"*("+rt+")"+ot+"*(?:([*^$|!

]?=)"+ot+"*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|("+st+")|)|)"+ot+"*\\]",nt=":("+rt+")(?:\\(((['\"])((?:\\\\.|[^\\\\])*?)\\3|((?:\\\\.|[^\\\\()[\\]]|"+it.replace(3,8)+")*)|.*)\\)|)",lt=new

RegExp("^"+ot+"+|((?:^|[^\\\\])(?:\\\\.)*)"+ot+"+$","g"),ut=new RegExp("^"+ot+"*,"+ot+"*"),dt=new RegExp("^"+ot+"*([>

]|"+ot

")"+ot+"*"),ct=new

RegExp("="+ot+"*([^\\]'\"]*?)"+ot+"*\\]","g"),pt=new RegExp(nt),ht=new RegExp("^"+st+"$"),mt={ID:new RegExp("^#("+rt+")"),CLASS:new

RegExp("^\\.("+rt+")"),TAG:new RegExp("^("+rt.replace("w","w*")+")"),ATTR:new RegExp("^"+it),PSEUDO:new RegExp("^"+nt),CHILD:new

RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+ot+"*(even|odd|(([+-]|)(\\d*)n|)"+ot+"*(?:([+-]|)"+ot+"*(\\d+)|))"+ot+"*\\)|)","i"),bool:new

RegExp("^(?:"+at+")$","i"),needsContext:new RegExp("^"+ot+"*[>]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+ot

"*((?:-\\d)?\\d*)"+ot+"*\\)|)(?=[^-]|$)","i")},ft=/^(?:input|select|textarea|button)$/i,gt=/^h\d$/i,vt=/^[^{]+\{\s*\[native

\w/,bt=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,yt=/[+~]/,wt=/'|\\/g,At=new RegExp("\\\\([\\da-f]{1,6}"+ot+"?|("+ot+")|.)","ig"),St=function(e,t,a){var

o="0x"+t-65536;return

o!==o||a?t:0>o?String.fromCharCode(o+65536):String.fromCharCode(o>>10|55296,1023&o|56320)};try{Z.apply(Q=et.call(H.childNodes),H.childNode

s),Q[H.childNodes.length].nodeType}catch(Ct){Z={apply:Q.length?function(e,t){J.apply(e,et.call(t))}:function(e,t){for(var

a=e.length,o=0;e[a++]=t[o++];);e.length=a-1}}}C=t.support={},D=t.isXML=function(e){var t=e&&(e.ownerDocument||e).documentElement;return

t?"HTML"!==t.nodeName:!1},F=t.setDocument=function(e){var t,a=e?e.ownerDocument||e:H,o=a.defaultView;return

a!==L&&9===a.nodeType&&a.documentElement?(L=a,T=a.documentElement,N=!D(a),o&&o!==o.top&&(o.addEventListener?o.addEventListener("un

load",function(){F()},!1):o.attachEvent&&o.attachEvent("onunload",function(){F()})),C.attributes=r(function(e){return

e.className="i",!e.getAttribute("className")}),C.getElementsByTagName=r(function(e){return

e.appendChild(a.createComment("")),!e.getElementsByTagName("*").length}),C.getElementsByClassName=vt.test(a.getElementsByClassName)&&r(

function(e){return e.innerHTML="<div class='a'></div><div class='a

i'></div>",e.firstChild.className="i",2===e.getElementsByClassName("i").length}),C.getById=r(function(e){return

T.appendChild(e).id=z,!a.getElementsByName||!a.getElementsByName(z).length}),C.getById?(P.find.ID=function(e,t){if(typeof

t.getElementById!==K&&N){var a=t.getElementById(e);return a&&a.parentNode?[a]:[]}},P.filter.ID=function(e){var t=e.replace(At,St);return

function(e){return e.getAttribute("id")===t}}):(delete P.find.ID,P.filter.ID=function(e){var t=e.replace(At,St);return function(e){var a=typeof

e.getAttributeNode!==K&&e.getAttributeNode("id");return a&&a.value===t}}),P.find.TAG=C.getElementsByTagName?function(e,t){return typeof

t.getElementsByTagName!==K?t.getElementsByTagName(e):void 0}:function(e,t){var

a,o=[],r=0,s=t.getElementsByTagName(e);if("*"===e){for(;a=s[r++];)1===a.nodeType&&o.push(a);return o}return

s},P.find.CLASS=C.getElementsByClassName&&function(e,t){return typeof

t.getElementsByClassName!==K&&N?t.getElementsByClassName(e):void

0},R=[],M=[],(C.qsa=vt.test(a.querySelectorAll))&&(r(function(e){e.innerHTML="<select t=''><option

selected=''></option></select>",e.querySelectorAll("[t^='']").length&&M.push("[*^$]="+ot+"*(?:''|\"\")"),e.querySelectorAll("[selected]").length||M.push("\\

["+ot+"*(?:value|"+at+")"),e.querySelectorAll(":checked").length||M.push(":checked")}),r(function(e){var

t=a.createElement("input");t.setAttribute("type","hidden"),e.appendChild(t).setAttribute("name","D"),e.querySelectorAll("[name=d]").length&&M.push("n

ame"+ot+"*[*^$|!~]?="),e.querySelectorAll(":enabled").length||M.push(":enabled",":disabled"),e.querySelectorAll("*,:x"),M.push(",.*:")})),(C.matchesSel

ector=vt.test(U=T.webkitMatchesSelector||T.mozMatchesSelector||T.oMatchesSelector||T.msMatchesSelector))&&r(function(e){C.disconnectedMatch

=U.call(e,"div"),U.call(e,"[s!='']:x"),R.push("!=",nt)}),M=M.length&&new RegExp(M.join("|")),R=R.length&&new

RegExp(R.join("|")),t=vt.test(T.compareDocumentPosition),B=t||vt.test(T.contains)?function(e,t){var

a=9===e.nodeType?e.documentElement:e,o=t&&t.parentNode;return

e===o||!(!o||1!==o.nodeType||!(a.contains?a.contains(o):e.compareDocumentPosition&&16&e.compareDocumentPosition(o)))}:function(e,t){if(t)for(;t=t

.parentNode;)if(t===e)return!0;return!1},j=t?function(e,t){if(e===t)return I=!0,0;var

o=!e.compareDocumentPosition-!t.compareDocumentPosition;return

o?o:(o=(e.ownerDocument||e)===(t.ownerDocument||t)?e.compareDocumentPosition(t):1,1&o||!C.sortDetached&&t.compareDocumentPosition(e)===

o?e===a||e.ownerDocument===H&&B(H,e)?-1:t===a||t.ownerDocument===H&&B(H,t)?1:E?tt.call(E,e)-tt.call(E,t):0:4&o?-1:1)}:function(e,t){if(e===t)r

eturn I=!0,0;var o,r=0,s=e.parentNode,n=t.parentNode,l=[e],u=[t];if(!s||!n)return e===a?-1:t===a?1:s?-1:n?1:E?tt.call(E,e)-tt.call(E,t):0;if(s===n)return

i(e,t);for(o=e;o=o.parentNode;)l.unshift(o);for(o=t;o=o.parentNode;)u.unshift(o);for(;l[r]===u[r];)r++;return

r?i(l[r],u[r]):l[r]===H?-1:u[r]===H?1:0},a):L},t.matches=function(e,a){return

t(e,null,null,a)},t.matchesSelector=function(e,a){if((e.ownerDocument||e)!==L&&F(e),a=a.replace(ct,"='$1']"),!(!C.matchesSelector||!N||R&&R.test(a)||M

&&M.test(a)))try{var o=U.call(e,a);if(o||C.disconnectedMatch||e.document&&11!==e.document.nodeType)return o}catch(r){}return

t(a,L,null,[e]).length>0},t.contains=function(e,t){return(e.ownerDocument||e)!==L&&F(e),B(e,t)},t.attr=function(e,t){(e.ownerDocument||e)!==L&&F(e);v

ar a=P.attrHandle[t.toLowerCase()],o=a&&Y.call(P.attrHandle,t.toLowerCase())?a(e,t,!N):void 0;return void

0!==o?o:C.attributes||!N?e.getAttribute(t):(o=e.getAttributeNode(t))&&o.specified?o.value:null},t.error=function(e){throw new Error("Syntax error,

unrecognized expression: "+e)},t.uniqueSort=function(e){var

t,a=[],o=0,r=0;if(I=!C.detectDuplicates,E=!C.sortStable&&e.slice(0),e.sort(j),I){for(;t=e[r++];)t===e[r]&&(o=a.push(r));for(;o--;)e.splice(a[o],1)}return

E=null,e},_=t.getText=function(e){var t,a="",o=0,r=e.nodeType;if(r){if(1===r||9===r||11===r){if("string"==typeof e.textContent)return

e.textContent;for(e=e.firstChild;e;e=e.nextSibling)a+=_(e)}else if(3===r||4===r)return e.nodeValue}else for(;t=e[o++];)a+=_(t);return

a},P=t.selectors={cacheLength:50,createPseudo:o,match:mt,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0},"

":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(e){return e

1

=e

1

.replace(At,St),e

3

=(e

4

||e

5

||"").replace(At,St),"~="===e

2

&&(e

3

=" "+e

3

+" "),e.slice(0,4)},CHILD:function(e){return e

1

=e

1

.toLowerCase(),"nth"===e

1

.slice(0,3)?(e

3

||t.error(e

0

),e

4

=+(e

4

?e

5

+(e

6

||1):2*("even"===e

3

||"odd"===e

3

)),e

5

=+(e

7

+e

8

||"odd"===e

3

)):e

3

&&t.error(e

0

),e},PSEUDO:function(e){var t,a=!e

5

&&e

2

;return mt.CHILD.test(e

0

)?null:(e

3

&&void 0!==e

4

?e

2

=e

4

:a&&pt.test(a)&&(t=p(a,!0))&&(t=a.indexOf(")",a.length-t)-a.length)&&(e

0

=e

0

.slice(0,t),e

2

=a.slice(0,t)),e.slice(0,3))}},filter:{TAG:function(e){var t=e.replace(At,St).toLowerCase();return"*"===e?function(){return!0}:function(e){return

e.nodeName&&e.nodeName.toLowerCase()===t}},CLASS:function(e){var t=V[e+" "];return t||(t=new RegExp("(

|"+ot+")"+e+"("+ot+"|$)"))&&V(e,function(e){return

t.test("string"==typeof e.className&&e.className||typeof e.getAttribute!==K&&e.getAttribute("class")||"")})},ATTR:function(e,a,o){return function(r){var s=t.attr(r,e);return

null==s?"!="===a:a?(s+="","="===a?s===o:"!="===a?s!==o:"

="===a?o&&0===s.indexOf(o):"*="===a?o&&s.indexOf(o)>

1:"$="===a?o&&s.slice(-o.length)===o:"~="===a?(" "+s+" ").indexOf(o)>-1:"|="===a?s===o||s.slice(0,o.length+1)===o+"

":!1):!0}},CHILD:function(e,t,a,o,r){var s="nth"!==e.slice(0,3),i="last"!==e.slice(4),n="of-type"===t;return

1===o&&0===r?function(e){return!!e.parentNode}:function(t,a,l){var

u,d,c,p,h,m,f=s!==i?"nextSibling":"previousSibling",g=t.parentNode,v=n&&t.nodeName.toLowerCase(),b=!l&&!n;if(g){if(s){for(;f;){for(c=t;c=c[f];)if(n?c.n

odeName.toLowerCase()===v:1===c.nodeType)return!1;m=f="only"===e&&!m&&"nextSibling"}return!0}if(m=[i?g.firstChild:g.lastChild],i&&b){for(d=g[z

]||(g[z]={}),u=d[e]||[],h=u

0

===O&&u

1

,p=u

0

===O&&u

2

,c=h&&g.childNodes[h];c=++h&&c&&c[f]||(p=h=0)||m.pop();)if(1===c.nodeType&&++p&&c===t){d[e]=[O,h,p];break}}else

if(b&&(u=(t[z]||(t[z]={}))[e])&&u

0

===O)p=u

1

;else

for(;(c=++h&&c&&c[f]||(p=h=0)||m.pop())&&((n?c.nodeName.toLowerCase()!==v:1!==c.nodeType)||!++p||(b&&((c[z]||(c[z]={}))[e]=[O,p]),c!==t)););return

p=r,p===o||p%o===0&&p/o>=0}}},PSEUDO:function(e,a){var r,s=P.pseudos[e]||P.setFilters[e.toLowerCase()]||t.error("unsupported pseudo:

"+e);return s[z]?s(a):s.length>1?(r=[e,e,"",a],P.setFilters.hasOwnProperty(e.toLowerCase())?o(function(e,t){for(var

o,r=s(e,a),i=r.length;i--;)o=tt.call(e,r[i]),e[o]=!(t[o]=r[i])}):function(e){return s(e,0,r)}):s}},pseudos:{not:o(function(e){var
t=[],a=[],r=x(e.replace(lt,"$1"));return r[z]?o(function(e,t,a,o){for(var s,i=r(e,null,o,[]),n=e.length;n--;)(s=i[n])&&(e[n]=!(t[n]=s))}):function(e,o,s){return t

0

=e,r(t,null,s,a),!a.pop()}}),has:o(function(e){return function(a){return t(e,a).length>0}}),contains:o(function(e){return

function(t){return(t.textContent||t.innerText||_(t)).indexOf(e)>1}}),lang:o(function(e){return ht.test(e||"")||t.error("unsupported lang:

"+e),e=e.replace(At,St).toLowerCase(),function(t){var a;do if(a=N?t.lang:t.getAttribute("xml:lang")||t.getAttribute("lang"))return

a=a.toLowerCase(),a===e||0===a.indexOf(e+"");while((t=t.parentNode)&&1===t.nodeType);return!1}}),target:function(t){var

a=e.location&&e.location.hash;return a&&a.slice(1)===t.id},root:function(e){return e===T},focus:function(e){return

e===L.activeElement&&(!L.hasFocus||L.hasFocus())&&!!(e.type||e.href||~e.tabIndex)},enabled:function(e){return

e.disabled===!1},disabled:function(e){return e.disabled===!0},checked:function(e){var

t=e.nodeName.toLowerCase();return"input"===t&&!!e.checked||"option"===t&&!!e.selected},selected:function(e){return

e.parentNode&&e.parentNode.selectedIndex,e.selected===!0},empty:function(e){for(e=e.firstChild;e;e=e.nextSibling)if(e.nodeType<6)return!1;return!

0},parent:function(e){return!P.pseudos.empty(e)},header:function(e){return gt.test(e.nodeName)},input:function(e){return

ft.test(e.nodeName)},button:function(e){var t=e.nodeName.toLowerCase();return"input"===t&&"button"===e.type||"button"===t},text:function(e){var

t;return"input"===e.nodeName.toLowerCase()&&"text"===e.type&&(null==(t=e.getAttribute("type"))||"text"===t.toLowerCase())},first:u(function(){return

0

}),last:u(function(e,t){return[t-1]}),eq:u(function(e,t,a){return[0>a?a+t:a]}),even:u(function(e,t){for(var a=0;t>a;a+=2)e.push(a);return

e}),odd:u(function(e,t){for(var a=1;t>a;a+=2)e.push(a);return e}),lt:u(function(e,t,a){for(var o=0>a?a+t:a;--o>=0;)e.push(o);return

e}),gt:u(function(e,t,a){for(var o=0>a?a+t:a;++o<t;)e.push(o);return e})}},P.pseudos.nth=P.pseudos.eq;for(S

in{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})P.pseudos[S]=n(S);for(S in{submit:!0,reset:!0})P.pseudos[S]=l(S);return

c.prototype=P.filters=P.pseudos,P.setFilters=new c,x=t.compile=function(e,t){var a,o=[],r=[],s=G[e+"

"];if(!s){for(t||(t=p(e)),a=t.length;a--;)s=b(t[a]),s[z]?o.push(s):r.push(s);s=G(e,y(r,o))}return

s},C.sortStable=z.split("").sort(j).join("")===z,C.detectDuplicates=!!I,F(),C.sortDetached=r(function(e){return

1&e.compareDocumentPosition(L.createElement("div"))}),r(function(e){return e.innerHTML="<a

href='#'></a>","#"===e.firstChild.getAttribute("href")})||s("type|href|height|width",function(e,t,a){return a?void

0:e.getAttribute(t,"type"===t.toLowerCase()?1:2)}),C.attributes&&r(function(e){return

e.innerHTML="<input/>",e.firstChild.setAttribute("value",""),""===e.firstChild.getAttribute("value")})||s("value",function(e,t,a){return

a||"input"!==e.nodeName.toLowerCase()?void 0:e.defaultValue}),r(function(e){return null==e.getAttribute("disabled")})||s(at,function(e,t,a){var o;return

a?void

0:e[t]===!0?t.toLowerCase():(o=e.getAttributeNode(t))&&o.specified?o.value:null}),t}(e);st.find=dt,st.expr=dt.selectors,st.expr[":"]=st.expr.pseudos,st.u

nique=dt.uniqueSort,st.text=dt.getText,st.isXMLDoc=dt.isXML,st.contains=dt.contains;var

ct=st.expr.match.needsContext,pt=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,ht=/^.[^:#\[\.,]*$/;st.filter=function(e,t,a){var o=t

0

;return

a&&(e=":not("+e+")"),1===t.length&&1===o.nodeType?st.find.matchesSelector(o,e)?[o]:[]:st.find.matches(e,st.grep(t,function(e){return

1===e.nodeType}))},st.fn.extend({find:function(e){var t,a=[],o=this,r=o.length;if("string"!=typeof e)return

this.pushStack(st(e).filter(function(){for(t=0;r>t;t++)if(st.contains(o[t],this))return!0}));for(t=0;r>t;t++)st.find(e,o[t],a);return

a=this.pushStack(r>1?st.unique(a):a),a.selector=this.selector?this.selector+" "+e:e,a},filter:function(e){return

this.pushStack(o(this,e||[],!1))},not:function(e){return this.pushStack(o(this,e||[],!0))},is:function(e){return!!o(this,"string"==typeof

e&&ct.test(e)?st(e):e||[],!1).length}});var mt,ft=e.document,gt=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/,vt=st.fn.init=function(e,t){var a,o;if(!e)return

this;if("string"==typeof e){if(a="<"===e.charAt(0)&&">"===e.charAt(e.length-1)&&e.length>=3?[null,e,null]:gt.exec(e),!a||!a

1

&&t)return!t||t.jquery?(t||mt).find(e):this.constructor(t).find(e);if(a

1

){if(t=t instanceof st?t

0

:t,st.merge(this,st.parseHTML(a

1

,t&&t.nodeType?t.ownerDocument||t:ft,!0)),pt.test(a

1

)&&st.isPlainObject(t))for(a in t)st.isFunction(this[a])?this[a](t[a]):this.attr(a,t[a]);return

this}if(o=ft.getElementById(a

2

),o&&o.parentNode){if(o.id!==a

2

)return mt.find(e);this.length=1,this

0

=o}return this.context=ft,this.selector=e,this}return

e.nodeType?(this.context=this

0

=e,this.length=1,this):st.isFunction(e)?"undefined"!=typeof mt.ready?mt.ready(e):e(st):(void

0!==e.selector&&(this.selector=e.selector,this.context=e.context),st.makeArray(e,this))};vt.prototype=st.fn,mt=st(ft);var

bt=/^(?:parents|prev(?:Until|All))/,yt={children:!0,contents:!0,next:!0,prev:!0};st.extend({dir:function(e,t,a){for(var o=[],r=e[t];r&&9!==r.nodeType&&(void

0===a||1!==r.nodeType||!st(r).is(a));)1===r.nodeType&&o.push(r),r=r[t];return o},sibling:function(e,t){for(var

a=[];e;e=e.nextSibling)1===e.nodeType&&e!==t&&a.push(e);return a}}),st.fn.extend({has:function(e){var t,a=st(e,this),o=a.length;return

this.filter(function(){for(t=0;o>t;t++)if(st.contains(this,a[t]))return!0})},closest:function(e,t){for(var a,o=0,r=this.length,s=[],i=ct.test(e)||"string"!=typeof

e?st(e,t||this.context):0;r>o;o++)for(a=this[o];a&&a!==t;a=a.parentNode)if(a.nodeType<11&&(i?i.index(a)>-1:1===a.nodeType&&st.find.matchesSelec

tor(a,e))){s.push(a);break}return this.pushStack(s.length>1?st.unique(s):s)},index:function(e){return e?"string"==typeof e?st.inArray(this

0

,st(e)):st.inArray(e.jquery?e

0

:e,this):this

0

&&this

0

.parentNode?this.first().prevAll().length:-1},add:function(e,t){return

this.pushStack(st.unique(st.merge(this.get(),st(e,t))))},addBack:function(e){return

this.add(null==e?this.prevObject:this.prevObject.filter(e))}}),st.each({parent:function(e){var t=e.parentNode;return

t&&11!==t.nodeType?t:null},parents:function(e){return st.dir(e,"parentNode")},parentsUntil:function(e,t,a){return

st.dir(e,"parentNode",a)},next:function(e){return r(e,"nextSibling")},prev:function(e){return r(e,"previousSibling")},nextAll:function(e){return

st.dir(e,"nextSibling")},prevAll:function(e){return st.dir(e,"previousSibling")},nextUntil:function(e,t,a){return

st.dir(e,"nextSibling",a)},prevUntil:function(e,t,a){return st.dir(e,"previousSibling",a)},siblings:function(e){return

st.sibling((e.parentNode||{}).firstChild,e)},children:function(e){return st.sibling(e.firstChild)},contents:function(e){return

st.nodeName(e,"iframe")?e.contentDocument||e.contentWindow.document:st.merge([],e.childNodes)}},function(e,t){st.fn[e]=function(a,o){var

r=st.map(this,t,a);return"Until"!==e.slice(5)&&(o=a),o&&"string"==typeof

o&&(r=st.filter(o,r)),this.length>1&&(yt[e]||(r=st.unique(r)),bt.test(e)&&(r=r.reverse())),this.pushStack(r)}});var

wt=/\S+/g,At={};st.Callbacks=function(e){e="string"==typeof e?At[e]||s(e):st.extend({},e);var

t,a,o,r,i,n,l=[],u=!e.once&&[],d=function(s){for(a=e.memory&&s,o=!0,i=n||0,n=0,r=l.length,t=!0;l&&r>i;i++)if(l[i].apply(s

0

,s

1

)===!1&&e.stopOnFalse){a=!1;break}t=!1,l&&(u?u.length&&d(u.shift()):a?l=[]:c.disable())},c={add:function(){if(l){var o=l.length;!function

s(t){st.each(t,function(t,a){var

o=st.type(a);"function"===o?e.unique&&c.has(a)||l.push(a):a&&a.length&&"string"!==o&&s(a)})}(arguments),t?r=l.length:a&&(n=o,d(a))}return

this},remove:function(){return l&&st.each(arguments,function(e,a){for(var o;(o=st.inArray(a,l,o))>-1;)l.splice(o,1),t&&(r>=o&&r-

,i>=o&&i--)}),this},has:function(e){return e?st.inArray(e,l)>1:!(!l||!l.length)},empty:function(){return l=[],r=0,this},disable:function(){return l=u=a=void

0,this},disabled:function(){return!l},lock:function(){return u=void

0,a||c.disable(),this},locked:function(){return!u},fireWith:function(e,a){return!l||o&&!u||(a=a||[],a=[e,a.slice?a.slice():a],t?u.push(a):d(a)),this},fire:function

(){return c.fireWith(this,arguments),this},fired:function(){return!!o}};return c},st.extend({Deferred:function(e){var t="resolve","done",st.Callbacks("once

memory"),"resolved"],["reject","fail",st.Callbacks("once memory"),"rejected"],["notify","progress",st.Callbacks("memory")

,a="pending",o={state:function(){return a},always:function(){return r.done(arguments).fail(arguments),this},then:function(){var e=arguments;return

st.Deferred(function(a){st.each(t,function(t,s){var i=st.isFunction(e[t])&&e[t];r[s

1

](function(){var

e=i&&i.apply(this,arguments);e&&st.isFunction(e.promise)?e.promise().done(a.resolve).fail(a.reject).progress(a.notify):a[s

0

+"With"](this===o?a.promise():this,i?[e]:arguments)})}),e=null}).promise()},promise:function(e){return null!=e?st.extend(e,o):o}},r={};return

o.pipe=o.then,st.each(t,function(e,s){var i=s

2

,n=s

3

;o[s

1

]=i.add,n&&i.add(function(){a=n},t[1^e][2].disable,t

2

[2].lock),r[s

0

]=function(){return r[s

0

+"With"](this===r?o:this,arguments),this},r[s

0

+"With"]=i.fireWith}),o.promise(r),e&&e.call(r,r),r},when:function(e){var

t,a,o,r=0,s=Y.call(arguments),i=s.length,n=1!==i||e&&st.isFunction(e.promise)?i:0,l=1===n?e:st.Deferred(),u=function(e,a,o){return
function(r){a[e]=this,o[e]=arguments.length>1?Y.call(arguments):r,o===t?l.notifyWith(a,o):--n||l.resolveWith(a,o)}};if(i>1)for(t=new Array(i),a=new

Array(i),o=new Array(i);i>r;r++)s[r]&&st.isFunction(s[r].promise)?s[r].promise().done(u(r,o,s)).fail(l.reject).progress(u(r,a,t)):--n;return

n||l.resolveWith(o,s),l.promise()}});var St;st.fn.ready=function(e){return

st.ready.promise().done(e),this},st.extend({isReady:!1,readyWait:1,holdReady:function(e){e?st.readyWait++:st.ready(!0)},ready:function(e){if(e===!0?!

--st.readyWait:!st.isReady){if(!ft.body)return

setTimeout(st.ready);st.isReady=!0,e!==!0&&--st.readyWait>0||(St.resolveWith(ft,[st]),st.fn.trigger&&st(ft).trigger("ready").off("ready"))}}}),st.ready.pro

mise=function(t){if(!St)if(St=st.Deferred(),"complete"===ft.readyState)setTimeout(st.ready);else

if(ft.addEventListener)ft.addEventListener("DOMContentLoaded",n,!1),e.addEventListener("load",n,!1);else{ft.attachEvent("onreadystatechange",n),e.

attachEvent("onload",n);var a=!1;try{a=null==e.frameElement&&ft.documentElement}catch(o){}a&&a.doScroll&&!function

r(){if(!st.isReady){try{a.doScroll("left")}catch(e){return setTimeout(r,50)}i(),st.ready()}}()}return St.promise(t)};var Ct,Pt="undefined";for(Ct in

st(ot))break;ot.ownLast="0"!==Ct,ot.inlineBlockNeedsLayout=!1,st(function(){var

e,t,a=ft.getElementsByTagName("body")[0];a&&(e=ft.createElement("div"),e.style.cssText="border:0;width:0;height:0;position:absolute;top:0;left:-999

9px;margin-top:1px",t=ft.createElement("div"),a.appendChild(e).appendChild(t),typeof

t.style.zoom!==Pt&&(t.style.cssText="border:0;margin:0;width:1px;padding:1px;display:inline;zoom:1",(ot.inlineBlockNeedsLayout=3===t.offsetWidth)

&&(a.style.zoom=1)),a.removeChild(e),e=t=null)}),function(){var e=ft.createElement("div");if(null==ot.deleteExpando){ot.deleteExpando=!0;try{delete

e.test}catch(t){ot.deleteExpando=!1}}e=null}(),st.acceptData=function(e){var t=st.noData[(e.nodeName+" ").toLowerCase()],a=+e.nodeType||1;return

1!==a&&9!==a?!1:!t||t!==!0&&e.getAttribute("classid")===t};var _t=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,Dt=/([A-Z])/g;st.extend({cache:{},noData:{"applet

":!0,"embed ":!0,"object ":"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"},hasData:function(e){return

e=e.nodeType?st.cache[e[st.expando]]:e[st.expando],!!e&&!u(e)},data:function(e,t,a){return d(e,t,a)},removeData:function(e,t){return

c(e,t)},_data:function(e,t,a){return d(e,t,a,!0)},_removeData:function(e,t){return c(e,t,!0)}}),st.fn.extend({data:function(e,t){var a,o,r,s=this

0

,i=s&&s.attributes;if(void 0===e){if(this.length&&(r=st.data(s),1===s.nodeType&&!st._data(s,"parsedAttrs"))){for(a=i.length;a-

;)o=i[a].name,0===o.indexOf("data-")&&(o=st.camelCase(o.slice(5)),l(s,o,r[o]));st._data(s,"parsedAttrs",!0)}return r}return"object"==typeof

e?this.each(function(){st.data(this,e)}):arguments.length>1?this.each(function(){st.data(this,e,t)}):s?l(s,e,st.data(s,e)):void

0},removeData:function(e){return this.each(function(){st.removeData(this,e)})}}),st.extend({queue:function(e,t,a){var o;return

e?(t=(t||"fx")+"queue",o=st._data(e,t),a&&(!o||st.isArray(a)?o=st._data(e,t,st.makeArray(a)):o.push(a)),o||[]):void 0},dequeue:function(e,t){t=t||"fx";var

a=st.queue(e,t),o=a.length,r=a.shift(),s=st._queueHooks(e,t),i=function(){st.dequeue(e,t)};"inprogress"===r&&(r=a.shift(),o--),r&&("fx"===t&&a.unshift(

"inprogress"),delete s.stop,r.call(e,i,s)),!o&&s&&s.empty.fire()},_queueHooks:function(e,t){var a=t+"queueHooks";return

st._data(e,a)||st._data(e,a,{empty:st.Callbacks("once

memory").add(function(){st._removeData(e,t+"queue"),st._removeData(e,a)})})}}),st.fn.extend({queue:function(e,t){var a=2;return"string"!=typeof

e&&(t=e,e="fx",a--),arguments.length<a?st.queue(this

0

,e):void 0===t?this:this.each(function(){var

a=st.queue(this,e,t);st._queueHooks(this,e),"fx"===e&&"inprogress"!==a

0

&&st.dequeue(this,e)})},dequeue:function(e){return

this.each(function(){st.dequeue(this,e)})},clearQueue:function(e){return this.queue(e||"fx",[])},promise:function(e,t){var

a,o=1,r=st.Deferred(),s=this,i=this.length,n=function(){--o||r.resolveWith(s,[s])};for("string"!=typeof e&&(t=e,e=void

0),e=e||"fx";i--;)a=st._data(s[i],e+"queueHooks"),a&&a.empty&&(o++,a.empty.add(n));return n(),r.promise(t)}});var

xt=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,kt=["Top","Right","Bottom","Left"],Et=function(e,t){return

e=t||e,"none"===st.css(e,"display")||!st.contains(e.ownerDocument,e)},It=st.access=function(e,t,a,o,r,s,i){var

n=0,l=e.length,u=null==a;if("object"===st.type(a)){r=!0;for(n in a)st.access(e,t,n,a[n],!0,s,i)}else if(void

0!==o&&(r=!0,st.isFunction(o)||(i=!0),u&&(i?(t.call(e,o),t=null):(u=t,t=function(e,t,a){return

u.call(st(e),a)})),t))for(;l>n;n++)t(e[n],a,i?o:o.call(e[n],n,t(e[n],a)));return r?e:u?t.call(e):l?t(e

0

,a):s},Ft=/^(?:checkbox|radio)$/i;!function(){var

e=ft.createDocumentFragment(),t=ft.createElement("div"),a=ft.createElement("input");if(t.setAttribute("className","t"),t.innerHTML=" 

<link/><table></table><a

href='/a'>a</a>",ot.leadingWhitespace=3===t.firstChild.nodeType,ot.tbody=!t.getElementsByTagName("tbody").length,ot.htmlSerialize=!!t.getElement

sByTagName("link").length,ot.html5Clone="<:nav></:nav>"!==ft.createElement("nav").cloneNode(!0).outerHTML,a.type="checkbox",a.checked=!0,e.a

ppendChild(a),ot.appendChecked=a.checked,t.innerHTML="<textarea>x</textarea>",ot.noCloneChecked=!!t.cloneNode(!0).lastChild.defaultValue,e.a

ppendChild(t),t.innerHTML="<input type='radio' checked='checked'

name='t'/>",ot.checkClone=t.cloneNode(!0).cloneNode(!0).lastChild.checked,ot.noCloneEvent=!0,t.attachEvent&&(t.attachEvent("onclick",function(){ot

.noCloneEvent=!1}),t.cloneNode(!0).click()),null==ot.deleteExpando){ot.deleteExpando=!0;try{delete

t.test}catch(o){ot.deleteExpando=!1}}e=t=a=null}(),function(){var t,a,o=ft.createElement("div");for(t

in{submit:!0,change:!0,focusin:!0})a="on"+t,(ot[t+"Bubbles"]=a in e)||(o.setAttribute(a,"t"),ot[t+"Bubbles"]=o.attributes[a].expando===!1);o=null}();var

Lt=/^(?:input|select|textarea)$/i,Tt=/^key/,Nt=/^(?:mouse|contextmenu)|click/,Mt=/^(?:focusinfocus|focusoutblur)$/,Rt=/^([^.]*)(?:\.(.+)|)$/;st.event={glob

al:{},add:function(e,t,a,o,r){var

s,i,n,l,u,d,c,p,h,m,f,g=st._data(e);if(g){for(a.handler&&(l=a,a=l.handler,r=l.selector),a.guid||(a.guid=st.guid++),(i=g.events)||(i=g.events={}),(d=g.handle)

||(d=g.handle=function(e){return typeof st===Pt||e&&st.event.triggered===e.type?void

0:st.event.dispatch.apply(d.elem,arguments)},d.elem=e),t=(t||"").match(wt)||[""],n=t.length;n--;)s=Rt.exec(t[n])||[],h=f=s

1

,m=(s

2

||"").split(".").sort(),h&&(u=st.event.special[h]||{},h=(r?u.delegateType:u.bindType)||h,u=st.event.special[h]||{},c=st.extend({type:h,origType:f,data:o,han

dler:a,guid:a.guid,selector:r,needsContext:r&&st.expr.match.needsContext.test(r),namespace:m.join(".")},l),(p=i[h])||(p=i[h]=[],p.delegateCount=0,u.set

up&&u.setup.call(e,o,m,d)!==!1||(e.addEventListener?e.addEventListener(h,d,!1):e.attachEvent&&e.attachEvent("on"+h,d))),u.add&&(u.add.call(e,c),c

.handler.guid||(c.handler.guid=a.guid)),r?p.splice(p.delegateCount++,0,c):p.push(c),st.event.global[h]=!0);e=null}},remove:function(e,t,a,o,r){var

s,i,n,l,u,d,c,p,h,m,f,g=st.hasData(e)&&st._data(e);if(g&&(d=g.events)){for(t=(t||"").match(wt)||[""],u=t.length;u--;)if(n=Rt.exec(t[u])||[],h=f=n

1

,m=(n

2

||"").split(".").sort(),h){for(c=st.event.special[h]||{},h=(o?c.delegateType:c.bindType)||h,p=d[h]||[],n=n

2

&&new RegExp("(

|\\.)"+m.join("\\.(?:.*\\.|)")+"(\\.|$)"),l=s=p.length;s--;)i=p[s],!r&&f!==i.origType||a&&a.guid!==i.guid||n&&!n.test(i.namespace)||o&&o!==i.selector&&("**"!==o||!i.selector)||(p.splice(s,1),i.selector&&p.delegateCount--,c.remove&&c.re

move.call(e,i));l&&!p.length&&(c.teardown&&c.teardown.call(e,m,g.handle)!==!1||st.removeEvent(e,h,g.handle),delete d[h])}else for(h in d)st.event.remove(e,h+t[u],a,o,!0);st.isEmptyObject(d)&&(delete

g.handle,st._removeData(e,"events"))}},trigger:function(t,a,o,r){var

s,i,n,l,u,d,c,p=[o||ft],h=tt.call(t,"type")?t.type:t,m=tt.call(t,"namespace")?t.namespace.split("."):[];if(n=d=o=o||ft,3!==o.nodeType&&8!==o.nodeType&&!Mt.test(h+st.event.triggered)&&(h.indexOf(".")>=0&&(m=h.split("."),h=m.shift(
),m.sort()),i=h.indexOf(":")<0&&"on"+h,t=t[st.expando]?t:new st.Event(h,"object"==typeof t&&t),t.isTrigger=r?2:3,t.namespace=m.join("."),t.namespace_re=t.namespace?new RegExp("(

|\\.)"+m.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,t.result=void

0,t.target||(t.target=o),a=null==a?[t]:st.makeArray(a,[t]),u=st.event.special[h]||{},r||!u.trigger||u.trigger.apply(o,a)!==!1)){if(!r&&!u.noBubble&&!st.isWindo

w(o)){for(l=u.delegateType||h,Mt.test(l+h)||(n=n.parentNode);n;n=n.parentNode)p.push(n),d=n;

....

In the production log I see a lot of:

2016-04-15 11:27:34 [app] [I]   Rendered nic/_provider_specific_form.html.erb (0.1ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/manageds/_managed.html.erb (10.9ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_base_form.html.erb (8.3ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_virtual_form.html.erb (1.2ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_provider_specific_form.html.erb (0.1ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/manageds/_managed.html.erb (10.9ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_base_form.html.erb (8.2ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_virtual_form.html.erb (1.2ms)

2016-04-15 11:27:34 [app] [I]   Rendered nic/_provider_specific_form.html.erb (0.1ms)

...

The host cld-corso-11.pd.infn.it is a CentOS7.2 built one week ago.

Any hint?

Cheers

Sergio

#4 - 04/15/2016 06:02 AM - Dominic Cleal

- Subject changed from Performance problem or sometime erron in javascript to Host edit slow to load with many network interfaces

- Status changed from Need more information to New

The "ignored_interface_identifiers" setting in the version you're using may be useful - you could add a wildcard to ignore certain interfaces from fact

imports, so you could avoid importing all of the virtual machine interfaces, which should speed it up.

#5 - 04/15/2016 06:08 AM - Sergio Traldi

Hi,

yes I add also br*, but the problem is still there. now I try to add br_ex*.

Have I to restart httpd or somthing other?

Cheers

Sergio

#6 - 04/15/2016 06:09 AM - Dominic Cleal

Settings should take immediate effect, but I don't think changing the setting will remove any interfaces already on the host, it will probably just ignore

them. It should only affect hosts updated from future fact imports.

#7 - 04/15/2016 06:16 AM - Sergio Traldi

I confirm the problem is still there also adding br* and br_ex* in ignored_interface_identifiers in foreman settings.

To solve problay I have to scratch the host (bulding it) or delete it from foreman and import it again or there are other methos to erase facts or to

ignore that facts?

Thank

Cheers

Sergio

#8 - 04/15/2016 06:26 AM - Sergio Traldi

Just other stange things. The host cld-corso-11.pd.infn.it has been built last week and at the while it has got this network configuration:

[root@cld-corso-11 ~]# ifconfig

enp2s0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500

inet 192.168.60.221  netmask 255.255.255.0  broadcast 192.168.60.255

...

enp3s0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500

inet6 fe80::e2cb:4eff:fe19:fa05  prefixlen 64  scopeid 0x20<link>

....

enp3s0.302: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500

inet 192.168.61.221  netmask 255.255.255.0  broadcast 192.168.61.255

...

enp3s0.303: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
inet 90.147.77.153  netmask 255.255.255.0  broadcast 90.147.77.255

...

lo: flags=73<UP,LOOPBACK,RUNNING>  mtu 65536

inet 127.0.0.1  netmask 255.0.0.0

...

So it hasn't got any bridge or virtualnetwork or other, just 2 interfaces and the second one with 2 adresses.
